mat <- matrix(rnorm(100), nrow=25, ncol=4)
tmp2 <- rowMeans(mat)
tmp3 <- max(tmp2)
round(tmp3, 2)
round(max(rowMeans(mat)), 2)

library(magrittr)
mat %>% rowMeans %>% max %>% round(.,2)
data(iris)
head(iris)

library(dplyr)
## select(iris, starts_with("P")) 
## select(iris, -Species)
## head(iris[,grep("Petal", colnames(iris))])
iris %>% select(contains("Petal")) %>% head
## head(iris[which(iris$Species == "setosa" & iris$Petal.Length < 5),])
iris %>% filter(Species=="setosa", Petal.Length < 5) %>% head
## iris[1:3, ]
## head(iris[order(iris$Petal.Length),])
iris %>% slice(1:3)
iris %>% arrange(Petal.Length) %>% head

## head(data.frame(iris, Sepal.Length.mm = iris$Sepal.Length*10))
iris %>% mutate(Sepal.Length.mm = Sepal.Length*10) %>% head
## mean(iris$Sepal.Length, na.rm=TRUE)
iris %>% summarise(sepalMean=mean(Sepal.Length, na.rm=TRUE))
## data.frame(aggregate(.~Species, data=iris, mean, simplify=TRUE), 
##       total=aggregate(Sepal.Length~Species, data=iris, length, simplify=TRUE)$Sepal.Length)
gb <- group_by(iris,Species) %>%  
  summarise(SL=mean(Sepal.Length), SW=mean(Sepal.Width), 
            PL=mean(Petal.Length), PW=mean(Petal.Width), total=n())
gb
## dim(iris[sample(1:nrow(iris), 50)])
iris %>% sample_n(50) %>% dim
## dim(iris[sample(1:nrow(iris), 50, replace=TRUE)])
iris %>% sample_n(50, replace=TRUE) %>% dim
## Sample 10% of observations
iris %>% sample_frac(0.10) %>% dim

library(readr)
superheroes <-"
    name, alignment, gender,         publisher
 Magneto,       bad,   male,            Marvel
   Storm,      good, female,            Marvel
Mystique,       bad, female,            Marvel
  Batman,      good,   male,                DC
   Joker,       bad,   male,                DC
Catwoman,       bad, female,                DC
 Hellboy,      good,   male, Dark Horse Comics
"
superheroes <- read_csv(superheroes, trim_ws = TRUE, skip = 1)

publishers <- "
  publisher, yr_founded
         DC,       1934
     Marvel,       1939
      Image,       1992
"
publishers <- read_csv(publishers, trim_ws = TRUE, skip = 1)
superheroes
publishers
inner_join(superheroes, publishers)
left_join(superheroes, publishers)
left_join(publishers, superheroes)
messy <- data.frame(site=c("a", "b", "c", "d", "e"), trt1=c(56,76,43,25,21), 
                    trt2=c(123,234,187,198,23))
messy

library(tidyr)
gm <- messy %>% gather(treatment, count, trt1:trt2)
gm

df <- data.frame(x = c("a.b", "a.d", "b.c"))
df
df %>% separate(x, c("A", "B")) 
gm %>% spread(key=treatment, value=count)
